A = round(rand(3,3) * 10)
LU = A; % works in-place

for k = 1:n
    LU(k+1:n, k) = LU(k+1:n, k) / LU(k, k);
    % divide by pivot (modifies the rest of this column)
    % note that LU(k, k) will not be modified anymore

    for i = k+1:n
        x = LU(i, k);
        for j = k+1:n % explicit loop intended
            LU(i, j) = LU(i, j) - x * LU(k, j); % causes scatter in sparse version
        end
        % reduce the rest of the matrix
    end
    % modify the lower-right submatrix, LU(i, k) will not be changed
end
% version for packed LU

U = triu(LU)
L = tril(LU, -1) + eye(size(LU))
% unpack to L and U, add identity diagonal to L

A - L * U
