M = round(rand(5, 3) * 10)

[m n] = size(M);
Q = eye(m, m); % crime against QR: explicit Q
R = M; % works inplace

elim = min(m - 1, n); % decide how many cols to eliminate to get triangular R
for i = 1:elim
	Aii = R(i, i);
	Ai_norm = sqrt(R(i:m, i)' * R(i:m, i));
	dii = abs(Ai_norm) * sign(sign(Aii) + 0.5); % !!! need zero-avoiding sign function !!!
	wii = Aii - dii;
	two_fi_inv_squared = -1 / (wii * dii);
	% calculate Householder reflection of the i-th column

	% f1 = sqrt(2 / two_fi_inv_squared)
	% fj' = fj * 2 / fi
	% fj' = fj * (2 / sqrt(2)) / sqrt(1 / two_fi_inv_squared)
	% fj' = fj * (2 / sqrt(2)) * sqrt(two_fi_inv_squared)
	% fj' / f1 = fj * two_fi_inv_squared % also contains normalization for v

	for j = i+1:n
		fj = wii * R(i, j); % the head of column i is replaced by wii
		fj = fj + R(i+1:m, i)' * R(i+1:m, j); % dot of lower-part of columns i and j
		fj = fj * two_fi_inv_squared;
		% calculate columns dot

		R(i, j) = R(i, j) - fj * wii;
		R(i+1:m, j) = R(i+1:m, j) - fj * R(i+1:m, i);
		% update jth column
	end
	% apply Householder reflections also to the other columns to the right

	for j = 1:m
		fj = wii * Q(j, i); % the head of column i is replaced by wii
		fj = fj + Q(j, i+1:m) * R(i+1:m, i); % dot of lower-part of columns i and j
		fj = fj * two_fi_inv_squared;
		% calculate columns dot

		Q(j, i) = Q(j, i) - fj * wii;
		Q(j, i+1:m) = Q(j, i+1:m) - fj * R(i+1:m, i)';
		% update jth column
	end
	% apply Householder reflections also to the right-hand-side columns, in transpose!

	R(i, i) = dii;
	R(i+1:m, i) = 0;
	% finally, clear the rest of the current column
end
% eliminate lower triangle of M, column by column
% note that this is guaranteed to be numerically stable without pivoting

factorization_error = Q * R - M
Q_orthogonality_error = Q * Q' - eye(size(Q))
% check result

Q
R
% print result

A = M' * M; % note that this may not be SPD
R_chol = chol(A, 'upper')
% see that R is similar to Cholesky

