O = [0 1; 1 3; 2 3; 2.5 4.9; 3 7];
%O = [0 1; 1 7; 2 3; 2.5 4.9; 3 7];
% observations of some 1D function
% O(:,1) are the arguments, a
% O(:,2) are the desired fit values, b

plot(O(:, 1), O(:, 2), '*k') % plot a-s, b-s
hold on

x = [1 -.1 .01]';
% guess 0x (deliberately a bad guess, to take a few steps)

a = 1.345;
% guess some parameter for outlier rejection

xx = linspace(min(O(:, 1)) - .5, max(O(:, 1)) + .5);
for i = 1:10
    yy = x(1) + x(2) * xx + x(3) * (xx.^2);
    plot(xx, yy, '-b') % plot the initial guess
    % evaluate the initial guess

    % we are trying to estimate b = p + qa + ra^2
    % where x = [p q r] is our unknown
    % h(x) = p + qa + ra^2, J = dh / dx = [1 a a^2]

    J = [ones(length(O), 1), O(:, 1), O(:, 1).^2];
    % calculate the Jacobian

    db = O(:,2) - x(1) - O(:, 1) * x(2) - O(:, 1).^2 * x(3);
    % calculate current error vector
    
    MAD = median(abs(db));
    s = 1.4826 * MAD;
    % calculate MAD
    
    w = zeros(length(db), 1);
    for j = 1:length(db)
        u = db(j) / s;
        if(abs(u) < 1e-6)
            w(j) = 1;
        elseif(abs(u) <= a)
            w(j) = 1 / u;
        else
            w(j) = a * sign(u) / u;
        end
    end
    W = diag(w);
    % calculate the robust weights

    dx = (J' * W * J) \ J' * W * db; norm_dx = norm(dx)
    % solve normal equation (backslash = solve)
    
    if(norm_dx < 1e-6)
        break
    end
    % see if we optimized

    x = x + dx
    % increment
end

yy = x(1) + x(2) * xx + x(3) * (xx.^2);
plot(xx, yy, '-r') % plot the fitted curve

plot(O(:, 1), O(:, 2), '*k') % plot a-s, b-s
plot(O(:, 1), O(:, 2), 'sw') % plot a-s, b-s
hold off
% evaluate the estimated model

ylim([0 10])
% keep the plot together
