syms r00 r01 r02 r10 r11 r12 r20 r21 r22 t0 t1 t2 real
R = [r00 r01 r02; r10 r11 r12; r20 r21 r22]
t = [t0 t1 t2]'
% we have a rotation matrix and a translation vector

qw = sqrt(1 + r00 + r11 + r22) / 2;
qx = (r21 - r12) / (4 * qw);
qy = (r02 - r20) / (4 * qw);
qz = (r10 - r01) / (4 * qw);
% simplified matrix to quaternion (would need several branches
% for numerical stability)

qnorm = simplify(sqrt([qx qy qz] * [qx qy qz]'));
halfangle = asin(qnorm);
% get half of the rotation angle

ax = simplify(qx / qnorm * 2 * halfangle);
ay = simplify(qy / qnorm * 2 * halfangle);
az = simplify(qz / qnorm * 2 * halfangle);
% get the rotation as axis-angle

vec = [ax ay az t0 t1 t2]'
Rtvec = [r00 r01 r02 r10 r11 r12 r20 r21 r22 t0 t1 t2]';
J = jacobian(vec, Rtvec);
% let matlab calculate the derivatives

syms qnorm_ qx_ qy_ qz_ qw_ ax_ ay_ az_ real
J = subs(J, ax, ax_)
J = subs(J, ay, ay_)
J = subs(J, az, az_)
J = subs(J, qx, qx_)
J = subs(J, qy, qy_)
J = subs(J, qz, qz_)
J = subs(J, qw, qw_)
J = subs(J, qnorm, qnorm_)
% try substituting common subexpressions to tame the beast

J = simple(J)

len_J = strcat(num2str(length(ccode(J)) / 1024), ' kB')
ccode(J)

%fileID = fopen('aa_Jacobian.h','w');
%fprintf(fileID, '%s', ccode(J));
%fclose(fileID);
% export to C
